# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%if "%{?rhel}" == "6"
%bcond_without repolib
%else
%bcond_with repolib
%endif

%global hname hibernate-orm

%define buildtag -redhat-1
%define reltag .SP1_redhat_1
%define namedversion %{version}.SP1
%global fullversion %{namedversion}%{?buildtag}

%define repodir %{_javadir}/repository.jboss.com/org/hibernate/%{version}%{?reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           hibernate4
Version:        4.2.0
Release:        7%{?reltag}%{?dist}
Epoch:          0
Summary:        Relational persistence and query service
License:        LGPLv2+
Group:          Database
URL:            http://www.hibernate.org/
%if 0
git clone git://git.app.eng.bos.redhat.com/hibernate/hibernate-core.git && cd %{hname}
git checkout %{namedversion}
cd .. && tar --exclude=.git\* -cfz %{hname}-%{namedversion}-src.tar.gz %{hname}
%endif

Source0:        %{hname}-%{namedversion}-src.tar.gz
Source1:        libraries.gradle
Patch0:         prod.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:  jpackage-utils
Requires:  java >= 1.6.0

BuildRequires:  jpackage-utils
BuildRequires:  java
BuildRequires:  gradle
BuildRequires:  ant 
BuildRequires:  ant-antlr 
BuildRequires:  antlr 
BuildRequires:  jboss-logging 
BuildRequires:  jboss-logging-tools  
BuildRequires:  jboss-jdeparser
BuildRequires:  hibernate3-commons-annotations
BuildRequires:  jakarta-commons-collections 
BuildRequires:  jboss-transaction-api_1.1_spec 
BuildRequires:  jandex
BuildRequires:  hibernate-jpa-2.0-api
BuildRequires:  javassist 
BuildRequires:  dom4j
BuildRequires:  c3p0
BuildRequires:  hibernate-beanvalidation-api 
BuildRequires:  slf4j-api
BuildRequires:  log4j-over-slf4j
BuildRequires:  jcl-over-slf4j
BuildRequires:  slf4j-log4j12
BuildRequires:  jul-to-slf4j
BuildRequires:  jboss-jacc-api_1.4_spec
BuildRequires:  java-classmate
BuildRequires:  jgroups
BuildRequires:  i18nlog
BuildRequires:  maven-wagon
############## for jaxb
BuildRequires:  glassfish-jaxb
BuildRequires:  glassfish-jaf
BuildRequires:  codemodel
BuildRequires:  jing
BuildRequires:  txw2
BuildRequires:  txwc2
BuildRequires:  relaxngcc
BuildRequires:  relaxngDatatype
BuildRequires:  istack-commons-buildtools
BuildRequires:  istack-commons-runtime
BuildRequires:  istack-commons-tools
BuildRequires:  rngom
BuildRequires:  args4j
BuildRequires:  xsom
BuildRequires:  dtd-parser
BuildRequires:  xml-resolver
BuildRequires:  jaxb2-commons-basics
BuildRequires:  apache-commons-logging
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-lang
BuildRequires:  jboss-jaxb-api_2.2_spec
BuildRequires:  annox
############## for jaxb end

BuildRequires:  rhq-pluginAnnotations
BuildRequires:  infinispan
BuildRequires:  infinispan-parent
BuildRequires:  infinispan-core
BuildRequires:  apache-commons-compress

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Hibernate is a powerful, ultra-high performance 
object/relational persistence and query service 
for Java. Hibernate lets you develop persistent 
objects following common Java idiom - including 
association, inheritance, polymorphism, composition 
and the Java collections framework. Extremely 
fine-grained, richly typed object models are 
possible. The Hibernate Query Language, designed 
as a "minimal" object-oriented extension to SQL, 
provides an elegant bridge between the object and 
relational worlds. Hibernate is now the most 
popular ORM solution for Java.

%if %with repolib
%package repolib
Summary:     Artifacts to be uploaded to a repository library
Group:       Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package zip
Summary:        Zip distrubution for %{name}
Group:          Development

%description zip
Zip distribution for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%package core
Summary:        Hibernate Core
Group:          Development/Java

Requires:       antlr-eap6
Requires:       jboss-logging
Requires:       hibernate3-commons-annotations
Requires:       jboss-transaction-api_1.1_spec 
Requires:       hibernate-jpa-2.0-api
Requires:       javassist-eap6 
Requires:       dom4j

%description core
Hibernate Core module.

%package c3p0
Summary:        Hibernate C3p0
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       c3p0

%description c3p0
Hibernate C3p0 module.

%package entitymanager
Summary:        Hibernate EntityManager
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}

%description entitymanager
Hibernate EntityManager module.

%package envers
Summary:        Hibernate Envers
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       %{name}-entitymanager = %{epoch}:%{version}-%{release}

%description envers
Hibernate Envers module.

%package infinispan
Summary:        Hibernate Infinispan
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       infinispan

%description infinispan
Hibernate Infinispan module.

%prep
%setup -q -n %{hname}
%patch0 -p1
# remove tests and unused modules
%{__rm} -rf hibernate-core/src/test
%{__rm} -rf hibernate-entitymanager/src/test
%{__rm} -rf hibernate-infinispan/src/test
%{__rm} -rf hibernate-c3p0/src/test
%{__rm} -rf databases
%{__rm} -rf documentation
%{__rm} -rf hibernate-ehcache
%{__rm} -rf hibernate-proxool
%{__rm} -rf hibernate-testing
%{__rm} -rf hibernate-osgi
%{__rm} changelog.txt
%{__rm} -rf hibernate-envers/src/main/java/org/hibernate/tool/ant
%{__rm} -rf hibernate-envers/src/main/java/org/hibernate/envers/ant
%{__cp} %{SOURCE1} .

%build
export LC_ALL=en_US.UTF-8
export GRADLE_USER_HOME=`pwd`/.gradle
export GROOVY_HOME=%{_javadir}
export _OPTS="--info --stacktrace -Djava.endorsed.dirs=${GRADLE_USER_HOME}/endorsed"
export JAVA_OPTS="-Xms512M -Xmx1024M -XX:MaxPermSize=512M -Djava.awt.headless=true"
export LOCAL_REPO=`pwd`/local
%{__mkdir_p} ${GRADLE_USER_HOME}/endorsed
%{__ln_s} `%{_bindir}/build-classpath jboss-jaxb-api_2.2_spec` ${GRADLE_USER_HOME}/endorsed/jaxb-api.jar
%{__rm} -rf ${LOCAL_REPO}
%{__mkdir_p} ${LOCAL_REPO}
%{__sed} -i "s|REPOSITORY_PLACE_HOLDER|`pwd`/maven2-brew|g" build.gradle
%{_bindir}/gradle ${_OPTS} clean install :release:buildReleaseBundles uploadArchives
#%{_bindir}/gradle ${_OPTS}  :release:buildReleaseBundles

%install
%{__rm} -rf %{buildroot}
# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p */target/libs/hibernate-*.jar %{buildroot}%{_javadir}/%{name}
echo "--------------------------------------------------------------------------"
ls -al %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in hibernate-*.jar; do mv ${jar} `echo $jar | sed "s|hibernate|%{name}|g"`; done)
echo "--------------------------------------------------------------------------"
ls -al %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{fullversion}*.jar; do ln -sf ${jar} `echo $jar| sed "s|%{name}|hibernate|g"`; done)
echo "--------------------------------------------------------------------------"
ls -al %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{fullversion}*.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{fullversion}||g"`; done)
# etc
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}/etc
%{__cp} -p etc/* %{buildroot}%{_datadir}/%{name}/etc

# pom
%add_to_maven_depmap org.hibernate hibernate-core %{fullversion} JPP %{name}-core
%add_to_maven_depmap org.hibernate hibernate-infinispan %{fullversion} JPP %{name}-infinispan
%add_to_maven_depmap org.hibernate hibernate-envers %{fullversion} JPP %{name}-envers
%add_to_maven_depmap org.hibernate hibernate-entitymanager %{fullversion} JPP %{name}-entitymanager
%add_to_maven_depmap org.hibernate hibernate-c3p0 %{fullversion} JPP %{name}-c3p0

install -d -m 755 %{buildroot}%{_mavenpomdir}
install -m 644 hibernate-core/target/poms/pom-default.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-core.pom
install -m 644 hibernate-envers/target/poms/pom-default.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-envers.pom
install -m 644 hibernate-entitymanager/target/poms/pom-default.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-entitymanager.pom
install -m 644 hibernate-infinispan/target/poms/pom-default.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-infinispan.pom
install -m 644 hibernate-c3p0/target/poms/pom-default.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-c3p0.pom

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr release/target/documentation/javadocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
    %{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
    %{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
    install -d -m 755 %{buildroot}%{repodir}
    install -d -m 755 %{buildroot}%{repodirlib}
    install -d -m 755 %{buildroot}%{repodirsrc}
    install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
    install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
    (cd %{buildroot}%{_javadir}/%{name} && for jar in %{name}-*-%{fullversion}*.jar; do cp -p ${jar} %{buildroot}%{repodirlib}/`echo $jar| sed "s|-%{fullversion}||g" | sed "s|%{name}|hibernate|g"`; done)
    (cd %{buildroot}%{_mavenpomdir} && for pom in JPP-%{name}*.pom; do cp -p ${pom} %{buildroot}%{repodirlib}/`echo $pom| sed "s|JPP-%{name}|hibernate|g"`; done)

    # we do not want hibernate-c3p0 be added into repo lib rpm ( nor deploy into mead repo )
    # since this is only for EWS, not EAP.
    %{__rm} -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/hibernate/hibernate-c3p0
    %{__rm} -rf %{buildroot}%{repodirlib}/hibernate-c3p0*
%endif

# dist
install -dm 755 %{buildroot}%{_javadir}/%{name}-fordev
%{__cp} release/target/hibernate-release*.zip %{buildroot}%{_javadir}/%{name}-fordev/hibernate-dist.zip
cd %{buildroot}%{_javadir}/%{name}-fordev/
unzip hibernate-dist.zip
rm -rf hibernate-release-%{version}.SP1%{?buildtag}/lib/optional/infinispan
rm hibernate-dist.zip
zip -r hibernate-dist.zip hibernate-release-%{version}.SP1%{?buildtag}
rm -rf hibernate-release-%{version}.SP1%{?buildtag}
cd -
# License
install -dm 755 %{buildroot}%{_docdir}/%{name}
%{__cp} -p lgpl.txt %{buildroot}%{_docdir}/%{name}

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}/lgpl.txt
%{_datadir}/%{name}
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%files core
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-core*.jar
%{_javadir}*/%{name}/hibernate-core*.jar
#poms
%{_mavenpomdir}/JPP-%{name}-core*.pom

%files c3p0
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-c3p0*.jar
%{_javadir}*/%{name}/hibernate-c3p0*.jar
#poms
%{_mavenpomdir}/JPP-%{name}-c3p0*.pom

%files entitymanager
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-entitymanager*.jar
%{_javadir}*/%{name}/hibernate-entitymanager*.jar
#poms
%{_mavenpomdir}/JPP-%{name}-entitymanager*.pom

%files envers
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-envers*.jar
%{_javadir}*/%{name}/hibernate-envers*.jar
#poms
%{_mavenpomdir}/JPP-%{name}-envers*.pom

%files infinispan
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-infinispan*.jar
%{_javadir}*/%{name}/hibernate-infinispan*.jar
#poms
%{_mavenpomdir}/JPP-%{name}-infinispan*.pom

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%files zip
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%dir %{_javadir}*/%{name}-fordev
%{_javadir}*/%{name}-fordev/*.zip

%changelog
* Mon Jul 08 2013 David Stahl <dstahl@redhat.com> 0:4.2.0-7
- Update infinspan version

* Mon Jul 08 2013 David Stahl <dstahl@redhat.com> 0:4.2.0-6
- Upgrade to 4.2.0.SP1-redhat-1

* Mon Jul 01 2013 David Stahl <dstahl@redhat.com> 0:4.2.0-5
- link javadoc directory
- Update dom4j version

* Mon Apr 15 2013 David Walluck <dwalluck@redhat.com> 0:4.2.0-4
- restore BuildRequires: xml-resolver
- version Requires
- use %%{_mavenpomdir} macro

* Mon Mar 18 2013 Dave Stahl <dstahl@redhat.com> 0:4.2.0-3.Final
- Updated build sequence

* Fri Mar 15 2013 Dave Stahl <dstahl@redhat.com> 0:4.2.0-2.Final
- Upgrade to 4.2.0-2.Final-redhat-1

* Fri Mar 15 2013 Dave Stahl <dstahl@redhat.com> 0:4.2.0-1.Final
- Upgrade to 4.2.0.Final-redhat-1

* Mon Mar 04 2013 Strong Liu <stliu@redhat.com> 0:4.2.0-1.CR2
- Upgrade to 4.2.0.CR2-redhat-1

* Sun Feb 17 2013 Strong Liu <stliu@redhat.com> 0:4.2.0-1.CR1
- Upgrade to 4.2.0.CR1-redhat-1

* Tue Jan 22 2013 David Walluck <dwalluck@redhat.com> 0:4.1.9-8
- add BuildRequires: xml-resolver
- set LC_ALL to en_US.UTF-8

* Wed Jan 09 2013 Strong Liu <stliu@redhat.com> 0:4.1.9-1.Final
- Upgrade to 4.1.9.Final-redhat-1

* Sat Oct 20 2012 Strong Liu <stliu@redhat.com> 0:4.1.6-7.Final
- Rollback changes David made, these are not supposed to go into EAP 6.0.1
- Fix dom4j version issue (JBPAPP-10237)

* Thu Sep 13 2012 Paul Gier <pgier@redhat.com> 0:4.1.6-3.5.Final
- Update pom patch to -redhat-2 to avoid Maven repo conflict with previous build

* Wed Sep 12 2012 Strong Liu <stliu@redhat.com> 0:4.1.6-3.4.Final
- Apply patch for issue JBPAPP-9859

* Wed Sep 05 2012 Strong Liu <stliu@redhat.com> 0:4.1.6-3.2.Final
- change release tag from .Final to .Final_redhat_1
- change javasist version to 3.15.0-GA-redhat-2

* Wed Sep 05 2012 Strong Liu <stliu@redhat.com> 0:4.1.6-3.1.Final
- change rhq version from -redhat-1 to -redhat-2

* Tue Sep 04 2012 David Walluck <dwalluck@redhat.com> 0:4.1.6-3.Final
- rebuild with new gradle build
- fix bad dir ownership in repolib and zip packages
- fix repolib option
- fix some macros
- remove jpackage-utils version requirement
- update License

* Wed Aug 22 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:4.1.6-2.10.Final.4
- Fix suffix back to -1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:4.1.6-2.10.Final.3
- Rebuild unsigned

* Fri Aug 08 2012 Strong Liu <stliu@redhat.com> - 0:4.1.5-2.10.Final.2
- Upgrade to 4.1.6.Final

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:4.1.3-2.9.Final.2
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:4.1.3-2.9.Final.1
- Rebuild using cache signing

* Tue Jun 26 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.9.Final
- Change to R antlr-eap6, javassist-eap6
- Remove hibernate-infinispan from zip 

* Thu May 25 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.8.Final
- Add patch to fix JBPAPP-9142

* Thu May 24 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.7.Final
- Upgrade to jboss-logging 3.1.1.Final in libraries.gradle

* Mon May 07 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.6.Final
- Upgrade to 4.1.3.Final-redhat-1

* Mon Apr 23 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.5.ER1
- Upgrade to 4.1.3.ER1-redhat-1

* Thu Apr 05 2012 Strong Liu <stliu@redhat.com> 4.1.2-2.4.Final
- Upgrade to 4.1.2.Final-redhat-1

* Tue Mar 27 2012 Strong Liu <stliu@redhat.com> 4.1.1-2.3.Final
- Upgrade to 4.1.1.Final-redhat-1

* Tue Mar 20 2012 Strong Liu <stliu@redhat.com> 4.0.3-2.2.Final
- Upgrade to 4.0.3.Final-redhat-1

* Mon Mar 07 2012 Strong Liu <stliu@redhat.com> 4.0.2-2.1.Final
- Apply patch to include HHH-6100 and HHH-5927

* Mon Mar 05 2012 Strong Liu <stliu@redhat.com> 4.0.2-2.0.Final
- Upgrade to 4.0.2

* Wed Feb 08 2012 Strong Liu <stliu@redhat.com> 4.0.1-1.9.Final
- Upgrade to 4.0.1

* Tue Dec 27 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.8.Final
- Make com.fasterxml:classmate dependency provided scope

* Mon Dec 26 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.7.Final
- Upgrade javassist dependey to 3.15.0-GA

* Mon Dec 19 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.6.Final
- Upgrade to 4.0.0.Final

* Fri Dec 16 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.5.CP07
- Rebuild to change javassist groupId to org.javassist

* Wed Dec 07 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.4.CP07
- Upgrade to 4.0.0.CP07

* Mon Nov 21 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.3.CP06
- Split hibernate artifacts into sub-package
- Note : hibernate-c3p0 is not included in the -repolib rpm, so this is not deploied into the MEAD repo
- but hibernate-c3p0 is in the -zip rpm

* Thu Nov 17 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.2.CP06
- Upgrade to 4.0.0.CP06
- Add hibernate-c3p0 package

* Sun Oct 30 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.1.CP05
- Upgrade to use jboss logging tool 1.0.0.CR1

* Sat May 07 2011 Strong Liu <stliu@redhat.com> 3.3.2-1.8.GA_CP04
- Rebuild



